varying highp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;

uniform vec4 u_scale_and_atlas_position;
void main()
{
	vec4 textureColor = texture2D(u_texture, v_texCoord);
	
	vec2 scale = u_scale_and_atlas_position.xy;
	vec2 atlasPosition = u_scale_and_atlas_position.zw;
	vec2 maskPosition = v_texCoord - atlasPosition;
	vec2 maskTexCoord = maskPosition / scale;
	vec4 maskColor = texture2D(u_texture1, maskTexCoord);

	gl_FragColor.rgb =  textureColor.rgb;
	gl_FragColor.a =  textureColor.a * maskColor.a;
}


